searchNodes=[{"doc":"Main module of Snowflakex.","ref":"Snowflakex.html","title":"Snowflakex","type":"module"},{"doc":"Obtain a new snowflake.Returns either {:ok, snowflake} or {:error, errormessage}.","ref":"Snowflakex.html#new/0","title":"Snowflakex.new/0","type":"function"},{"doc":"Obtain a new snowflake.Raises Snowflakex.ClockError on error.","ref":"Snowflakex.html#new!/0","title":"Snowflakex.new!/0","type":"function"},{"doc":"Callback implementation for Application.start/2.","ref":"Snowflakex.html#start/2","title":"Snowflakex.start/2","type":"function"},{"doc":"Worker module for Snowflakex.Implements a GenServer.Do not use this directly, call Snowflakex.new/0 or Snowflakex.new!/0 instead.","ref":"Snowflakex.Worker.html","title":"Snowflakex.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Snowflakex.Worker.html#child_spec/1","title":"Snowflakex.Worker.child_spec/1","type":"function"},{"doc":"","ref":"Snowflakex.Worker.html#start_link/1","title":"Snowflakex.Worker.start_link/1","type":"function"},{"doc":"The snowflake could not be obtained due to the system clock moving backwards.","ref":"Snowflakex.ClockError.html","title":"Snowflakex.ClockError","type":"exception"},{"doc":"SnowflakexSnowflakex (pronounced &quot;snowflakes&quot;) is a service for generating unique ID numbers at high scale with some simple guarantees.It is directly modeled after Twitter's Snowflake specification.","ref":"readme.html","title":"Snowflakex","type":"extras"},{"doc":"PerformanceMinimum 10k IDs per second per nodeResponse rate &lt;= 2msUncoordinatedFor high availability within and across server application instances, nodes generating IDs should not have to coordinate with each other.(Roughly) Time OrderedWe can guarantee, that the ID numbers will be k-sorted (references: http://portal.acm.org/citation.cfm?id=70413.70419 and http://portal.acm.org/citation.cfm?id=110778.110783) within a reasonable bound (we're promising 1s, but shooting for 10's of ms).Directly SortableThe IDs should be sortable without loading the full objects that they represent. This sorting should be the above ordering.CompactThere are many otherwise reasonable solutions to this problem that require 128-bit numbers. To accomodate most systems, we keep our IDs under 64 bits.Highly AvailableThe ID generation scheme should be at least as available as the related services.","ref":"readme.html#requirements","title":"Snowflakex - Requirements","type":"extras"},{"doc":"The ID numbers are 64-bit integers composed of:Unused sign bit kept at 0Timestamp - 41 bits (millisecond precision with a custom epoch gives us 69 years)Configured machine id - 10 bits - gives us up to 1024 machinesSequence number - 12 bits - rolls over every 4096 per machine (with protection to avoid rollover in the same ms)","ref":"readme.html#solution","title":"Snowflakex - Solution","type":"extras"},{"doc":"You should use NTP to keep your system clock accurate. Snowflakex protects from non-monotonic clocks, i.e. clocks that run backwards. If your clock is running fast and NTP tells it to repeat a few milliseconds, snowflakex will refuse to generate ids until a time that is after the last time we generated an id. Even better, run in a mode where ntp won't move the clock backwards. See http://wiki.dovecot.org/TimeMovedBackwards#Time_synchronization for tips on how to do this.","ref":"readme.html#system-clock-dependency","title":"Snowflakex - System Clock Dependency","type":"extras"},{"doc":"The package can be installed as:Add snowflakex to your list of dependencies in mix.exs: def deps do [{:snowflakex, &quot;~&gt; 1.1.1&quot;}] endConfigure the machine id through your config.exs: config :snowflakex, machine_id: 123","ref":"readme.html#installation","title":"Snowflakex - Installation","type":"extras"},{"doc":"The library only offers two simple calls:Snowflakex.new()This call either returns {:ok, snowflake} or {:error, errormessage} where the latter only occurs when the system clock moved backwards.Snowflakex.new!()This call will either return the snowflake directly or raise a Snowflakex.ClockError with the error message and remaining time.","ref":"readme.html#usage","title":"Snowflakex - Usage","type":"extras"}]